# Generated by Django 2.2.9 on 2020-02-02 08:11

import _socket
import django.contrib.sites.managers
from django.db import migrations, models
import django.db.models.deletion
import django_audit_fields.fields.hostname_modification_field
import django_audit_fields.fields.userfield
import django_audit_fields.fields.uuid_auto_field
import django_audit_fields.models.audit_model_mixin
import django_revision.revision_field
import edc_model.validators.date
import edc_protocol.validators
import edc_utils.date
import edc_visit_tracking.managers


class Migration(migrations.Migration):

    dependencies = [
        ("sites", "0002_alter_domain_unique"),
        ("inte_subject", "0001_initial"),
    ]

    operations = [
        migrations.DeleteModel(name="GeneralAssessmentInitial",),
        migrations.RemoveField(
            model_name="historicalgeneralassessmentinitial", name="diabetes_informed",
        ),
        migrations.RemoveField(
            model_name="historicalgeneralassessmentinitial", name="diabetes_screen",
        ),
        migrations.RemoveField(
            model_name="historicalgeneralassessmentinitial",
            name="diabetes_screen_date",
        ),
        migrations.RemoveField(
            model_name="historicalgeneralassessmentinitial", name="hiv_informed",
        ),
        migrations.RemoveField(
            model_name="historicalgeneralassessmentinitial", name="hiv_screen",
        ),
        migrations.RemoveField(
            model_name="historicalgeneralassessmentinitial", name="hiv_screen_date",
        ),
        migrations.RemoveField(
            model_name="historicalgeneralassessmentinitial",
            name="hypertension_informed",
        ),
        migrations.RemoveField(
            model_name="historicalgeneralassessmentinitial", name="hypertension_screen",
        ),
        migrations.RemoveField(
            model_name="historicalgeneralassessmentinitial",
            name="hypertension_screen_date",
        ),
        migrations.AddField(
            model_name="historicalgeneralassessmentinitial",
            name="attending_hiv_clinic",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("N/A", "Not applicable")],
                default="N/A",
                max_length=15,
                verbose_name="Are you receiving care at an HIV clinic",
            ),
        ),
        migrations.AddField(
            model_name="historicalgeneralassessmentinitial",
            name="attending_ncd_clinic",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("N/A", "Not applicable")],
                default="N/A",
                max_length=15,
                verbose_name="Are you receiving care at an NCD clinic",
            ),
        ),
        migrations.AddField(
            model_name="historicalgeneralassessmentinitial",
            name="diabetic",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("unknown", "Unknown")],
                default="Yes",
                max_length=25,
                verbose_name="Have you previously been diagnosed with <u>diabetes</ul> (high blood sugar)?",
            ),
            preserve_default=False,
        ),
        migrations.AddField(
            model_name="historicalgeneralassessmentinitial",
            name="hiv_clinic_nearby",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("N/A", "Not applicable")],
                default="N/A",
                max_length=15,
                verbose_name="Do you attend the HIV clinic within this facility",
            ),
        ),
        migrations.AddField(
            model_name="historicalgeneralassessmentinitial",
            name="hiv_status",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("unknown", "Unknown")],
                default="Yes",
                max_length=15,
                verbose_name="Have you previously tested positive for HIV",
            ),
            preserve_default=False,
        ),
        migrations.AddField(
            model_name="historicalgeneralassessmentinitial",
            name="hypertensive",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("unknown", "Unknown")],
                default="Yes",
                max_length=25,
                verbose_name="Have you previously been diagnosed with <u>hypertension<ul> (high blood pressure)?",
            ),
            preserve_default=False,
        ),
        migrations.AddField(
            model_name="historicalgeneralassessmentinitial",
            name="ncd_clinic_nearby",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No"), ("N/A", "Not applicable")],
                default="N/A",
                max_length=15,
                verbose_name="Do you attend the NCD clinic within this facility",
            ),
        ),
        migrations.CreateModel(
            name="GeneralAssessmentInitial",
            fields=[
                (
                    "revision",
                    django_revision.revision_field.RevisionField(
                        blank=True,
                        editable=False,
                        help_text="System field. Git repository tag:branch:commit.",
                        max_length=75,
                        null=True,
                        verbose_name="Revision",
                    ),
                ),
                (
                    "created",
                    models.DateTimeField(
                        blank=True,
                        default=django_audit_fields.models.audit_model_mixin.utcnow,
                    ),
                ),
                (
                    "modified",
                    models.DateTimeField(
                        blank=True,
                        default=django_audit_fields.models.audit_model_mixin.utcnow,
                    ),
                ),
                (
                    "user_created",
                    django_audit_fields.fields.userfield.UserField(
                        blank=True,
                        help_text="Updated by admin.save_model",
                        max_length=50,
                        verbose_name="user created",
                    ),
                ),
                (
                    "user_modified",
                    django_audit_fields.fields.userfield.UserField(
                        blank=True,
                        help_text="Updated by admin.save_model",
                        max_length=50,
                        verbose_name="user modified",
                    ),
                ),
                (
                    "hostname_created",
                    models.CharField(
                        blank=True,
                        default=_socket.gethostname,
                        help_text="System field. (modified on create only)",
                        max_length=60,
                    ),
                ),
                (
                    "hostname_modified",
                    django_audit_fields.fields.hostname_modification_field.HostnameModificationField(
                        blank=True,
                        help_text="System field. (modified on every save)",
                        max_length=50,
                    ),
                ),
                ("device_created", models.CharField(blank=True, max_length=10)),
                ("device_modified", models.CharField(blank=True, max_length=10)),
                (
                    "id",
                    django_audit_fields.fields.uuid_auto_field.UUIDAutoField(
                        blank=True,
                        editable=False,
                        help_text="System auto field. UUID primary key.",
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                (
                    "consent_model",
                    models.CharField(editable=False, max_length=50, null=True),
                ),
                (
                    "consent_version",
                    models.CharField(editable=False, max_length=10, null=True),
                ),
                (
                    "report_datetime",
                    models.DateTimeField(
                        default=edc_utils.date.get_utcnow,
                        help_text="If reporting today, use today's date/time, otherwise use the date/time this information was reported.",
                        validators=[
                            edc_protocol.validators.datetime_not_before_study_start,
                            edc_model.validators.date.datetime_not_future,
                        ],
                        verbose_name="Report Date",
                    ),
                ),
                (
                    "hiv_status",
                    models.CharField(
                        choices=[("Yes", "Yes"), ("No", "No"), ("unknown", "Unknown")],
                        max_length=15,
                        verbose_name="Have you previously tested positive for HIV",
                    ),
                ),
                (
                    "attending_hiv_clinic",
                    models.CharField(
                        choices=[
                            ("Yes", "Yes"),
                            ("No", "No"),
                            ("N/A", "Not applicable"),
                        ],
                        default="N/A",
                        max_length=15,
                        verbose_name="Are you receiving care at an HIV clinic",
                    ),
                ),
                (
                    "hiv_clinic_nearby",
                    models.CharField(
                        choices=[
                            ("Yes", "Yes"),
                            ("No", "No"),
                            ("N/A", "Not applicable"),
                        ],
                        default="N/A",
                        max_length=15,
                        verbose_name="Do you attend the HIV clinic within this facility",
                    ),
                ),
                (
                    "diabetic",
                    models.CharField(
                        choices=[("Yes", "Yes"), ("No", "No"), ("unknown", "Unknown")],
                        max_length=25,
                        verbose_name="Have you previously been diagnosed with <u>diabetes</ul> (high blood sugar)?",
                    ),
                ),
                (
                    "hypertensive",
                    models.CharField(
                        choices=[("Yes", "Yes"), ("No", "No"), ("unknown", "Unknown")],
                        max_length=25,
                        verbose_name="Have you previously been diagnosed with <u>hypertension<ul> (high blood pressure)?",
                    ),
                ),
                (
                    "attending_ncd_clinic",
                    models.CharField(
                        choices=[
                            ("Yes", "Yes"),
                            ("No", "No"),
                            ("N/A", "Not applicable"),
                        ],
                        default="N/A",
                        max_length=15,
                        verbose_name="Are you receiving care at an NCD clinic",
                    ),
                ),
                (
                    "ncd_clinic_nearby",
                    models.CharField(
                        choices=[
                            ("Yes", "Yes"),
                            ("No", "No"),
                            ("N/A", "Not applicable"),
                        ],
                        default="N/A",
                        max_length=15,
                        verbose_name="Do you attend the NCD clinic within this facility",
                    ),
                ),
                (
                    "site",
                    models.ForeignKey(
                        editable=False,
                        null=True,
                        on_delete=django.db.models.deletion.PROTECT,
                        related_name="+",
                        to="sites.Site",
                    ),
                ),
                (
                    "subject_visit",
                    models.OneToOneField(
                        on_delete=django.db.models.deletion.PROTECT,
                        to="inte_subject.SubjectVisit",
                    ),
                ),
            ],
            options={
                "verbose_name": "General Assessment (Baseline)",
                "verbose_name_plural": "General Assessment (Baseline)",
                "abstract": False,
            },
            managers=[
                ("on_site", django.contrib.sites.managers.CurrentSiteManager()),
                ("objects", edc_visit_tracking.managers.CrfModelManager()),
            ],
        ),
        migrations.AddIndex(
            model_name="generalassessmentinitial",
            index=models.Index(
                fields=["subject_visit", "site", "id"],
                name="inte_subjec_subject_c7b4f0_idx",
            ),
        ),
    ]
