# Generated by Django 2.2.9 on 2020-02-13 17:55

import django.core.validators
from django.db import migrations, models


class Migration(migrations.Migration):

    dependencies = [
        ("inte_subject", "0004_auto_20200204_1320"),
    ]

    operations = [
        migrations.RemoveField(
            model_name="historicalriskfactors", name="alcohol_preference",
        ),
        migrations.RemoveField(
            model_name="historicalriskfactors", name="smoker_cigarettes_per_day",
        ),
        migrations.RemoveField(
            model_name="historicalriskfactors", name="smoker_current",
        ),
        migrations.RemoveField(
            model_name="historicalriskfactors", name="smoker_last_12m",
        ),
        migrations.RemoveField(model_name="riskfactors", name="alcohol_preference",),
        migrations.RemoveField(
            model_name="riskfactors", name="smoker_cigarettes_per_day",
        ),
        migrations.RemoveField(model_name="riskfactors", name="smoker_current",),
        migrations.RemoveField(model_name="riskfactors", name="smoker_last_12m",),
        migrations.AddField(
            model_name="generalassessmentinitial",
            name="hiv_next_appt_date",
            field=models.DateField(
                blank=True, null=True, verbose_name="When is your next HIV appointment"
            ),
        ),
        migrations.AddField(
            model_name="generalassessmentinitial",
            name="ncd_next_appt_date",
            field=models.DateField(
                blank=True, null=True, verbose_name="When is your next NCD appointment"
            ),
        ),
        migrations.AddField(
            model_name="historicalgeneralassessmentinitial",
            name="hiv_next_appt_date",
            field=models.DateField(
                blank=True, null=True, verbose_name="When is your next HIV appointment"
            ),
        ),
        migrations.AddField(
            model_name="historicalgeneralassessmentinitial",
            name="ncd_next_appt_date",
            field=models.DateField(
                blank=True, null=True, verbose_name="When is your next NCD appointment"
            ),
        ),
        migrations.AddField(
            model_name="historicalriskfactors",
            name="smoker_quit_ago_months",
            field=models.IntegerField(default=0, editable=False),
            preserve_default=False,
        ),
        migrations.AddField(
            model_name="historicalriskfactors",
            name="smoker_quit_ago_str",
            field=models.CharField(
                blank=True,
                help_text="Duration since last smoked. Format is `YYyMMm`. For example 1y11m, 12y7m, etc",
                max_length=8,
                null=True,
                validators=[
                    django.core.validators.RegexValidator(
                        "^([0-9]{1,3}y([0-5]?[0-9]m)?)$",
                        message="Invalid format. Expected something like 3y5m, 1y0m, etc",
                    )
                ],
                verbose_name="If you used to smoke but stopped, how long ago did you stop",
            ),
        ),
        migrations.AddField(
            model_name="historicalriskfactors",
            name="smoking_status",
            field=models.CharField(
                choices=[
                    ("smoker", "Currently smoke"),
                    ("former_smoker", "Used to smoke but stopped"),
                    ("nonsmoker", "Never smoked"),
                ],
                default="new_field",
                max_length=15,
                verbose_name="Which of these options describes you",
            ),
            preserve_default=False,
        ),
        migrations.AddField(
            model_name="riskfactors",
            name="smoker_quit_ago_months",
            field=models.IntegerField(default=0, editable=False),
            preserve_default=False,
        ),
        migrations.AddField(
            model_name="riskfactors",
            name="smoker_quit_ago_str",
            field=models.CharField(
                blank=True,
                help_text="Duration since last smoked. Format is `YYyMMm`. For example 1y11m, 12y7m, etc",
                max_length=8,
                null=True,
                validators=[
                    django.core.validators.RegexValidator(
                        "^([0-9]{1,3}y([0-5]?[0-9]m)?)$",
                        message="Invalid format. Expected something like 3y5m, 1y0m, etc",
                    )
                ],
                verbose_name="If you used to smoke but stopped, how long ago did you stop",
            ),
        ),
        migrations.AddField(
            model_name="riskfactors",
            name="smoking_status",
            field=models.CharField(
                choices=[
                    ("smoker", "Currently smoke"),
                    ("former_smoker", "Used to smoke but stopped"),
                    ("nonsmoker", "Never smoked"),
                ],
                default="new_field",
                max_length=15,
                verbose_name="Which of these options describes you",
            ),
            preserve_default=False,
        ),
        migrations.AlterField(
            model_name="historicalriskfactors",
            name="alcohol",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No")],
                max_length=15,
                verbose_name="Do you drink alcohol?",
            ),
        ),
        migrations.AlterField(
            model_name="historicalriskfactors",
            name="alcohol_consumption",
            field=models.CharField(
                choices=[
                    ("1_day_per_wk", "About once a week"),
                    ("2-3_day_per_wk", "2-3 days every week"),
                    ("most_days_per_month", "Most days in a month"),
                    ("N/A", "Not applicable"),
                ],
                default="N/A",
                max_length=25,
                verbose_name="If yes, how often do you drink alcohol?",
            ),
        ),
        migrations.AlterField(
            model_name="riskfactors",
            name="alcohol",
            field=models.CharField(
                choices=[("Yes", "Yes"), ("No", "No")],
                max_length=15,
                verbose_name="Do you drink alcohol?",
            ),
        ),
        migrations.AlterField(
            model_name="riskfactors",
            name="alcohol_consumption",
            field=models.CharField(
                choices=[
                    ("1_day_per_wk", "About once a week"),
                    ("2-3_day_per_wk", "2-3 days every week"),
                    ("most_days_per_month", "Most days in a month"),
                    ("N/A", "Not applicable"),
                ],
                default="N/A",
                max_length=25,
                verbose_name="If yes, how often do you drink alcohol?",
            ),
        ),
    ]
